/*
 * This program is Copyright (C) 2011 P. Lutus
 * http://arachnoid.com/messages
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA.
 */
 package Arachnophilia;

/*
 * SplashWindow.java
 *
 * Created on February 27, 2002, 9:47 AM
 */

import java.awt.*;

/**
 *
 * @author  Administrator
 */
final public class SplashWindow extends javax.swing.JWindow {

    Arachnophilia main = null;
    /** Creates new form SplashWindow */
    public SplashWindow()
    {
        init();
    }
    public SplashWindow(Arachnophilia m) {
        main = m;
        init();
    }
    
    private void init()
    {
        initComponents();
        appName.setText("<html><b><h1>" + ArachConstants.APPNAME + "</h1></b></html>");
        prompt.setFont(new Font("Courier",Font.PLAIN,12));
        String path = (main != null)?main.basePath:"(path)";
        String content = "<html><b>Please stand by as Arachnophilia installs its user files.<p>"
        + "Now installing directories and files at:<br>" + path + "</b></html>";
        explain.setText(content);
        
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        int w = screenSize.width/5;
        int h = screenSize.height/5;
        setBounds(w,h,screenSize.width-w*2,screenSize.height-h*2);
        setVisible(true);
    }
    
    public void append(String s)
    {
        prompt.append(s + "\n");
        prompt.setCaretPosition(prompt.getDocument().getLength()-1);
        //repaint();
        requestFocusInWindow();
        //pause();
    }
    
    private void pause()
    {
        try {
        Thread.sleep(1000);
        }
        catch(Exception e) {
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        thePane = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        prompt = new javax.swing.JTextArea();
        appName = new javax.swing.JLabel();
        explain = new javax.swing.JLabel();
        closeButton = new MyJButton();
        
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });
        
        thePane.setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;
        
        thePane.setBackground(java.awt.Color.white);
        thePane.setBorder(new javax.swing.border.LineBorder(java.awt.Color.black, 2));
        jButton1.setBackground(java.awt.Color.white);
        jButton1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Arachnophilia/arach.gif")));
        jButton1.setText(" ");
        jButton1.setToolTipText("Arachie says \"Hi\"");
        jButton1.setBorder(null);
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.insets = new java.awt.Insets(8, 8, 8, 8);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.NORTHWEST;
        thePane.add(jButton1, gridBagConstraints1);
        
        prompt.setLineWrap(true);
        prompt.setWrapStyleWord(true);
        prompt.setMargin(new java.awt.Insets(4, 4, 4, 4));
        jScrollPane1.setViewportView(prompt);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 2;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(4, 8, 8, 8);
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        thePane.add(jScrollPane1, gridBagConstraints1);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(8, 8, 4, 4);
        gridBagConstraints1.weightx = 1.0;
        thePane.add(appName, gridBagConstraints1);
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(4, 8, 4, 12);
        gridBagConstraints1.weightx = 1.0;
        thePane.add(explain, gridBagConstraints1);
        
        closeButton.setText("Close");
        closeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeButtonActionPerformed(evt);
            }
        });
        
        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.insets = new java.awt.Insets(4, 4, 4, 4);
        thePane.add(closeButton, gridBagConstraints1);
        
        getContentPane().add(thePane, java.awt.BorderLayout.CENTER);
        
        pack();
    }//GEN-END:initComponents

    private void closeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeButtonActionPerformed
        // Add your handling code here:
        quit();
    }//GEN-LAST:event_closeButtonActionPerformed

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        //System.exit(0);
        quit();
    }//GEN-LAST:event_exitForm

    
    private void quit()
    {
        setVisible(false);
        dispose();
    }
    
    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        new SplashWindow().setVisible(true);
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel thePane;
    private javax.swing.JButton jButton1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea prompt;
    private javax.swing.JLabel appName;
    private javax.swing.JLabel explain;
    private javax.swing.JButton closeButton;
    // End of variables declaration//GEN-END:variables

}
